#include <isamfile.hpp>
#include <cla_file.h>

class TClaField : public DBField {
public:
	virtual Boolean Get( void* rec, void* );
	virtual Boolean Set( void* rec, void* );
};


class TClaFile : public ISAMFile {
public:
	TClaFile();
	virtual ~TClaFile();
	virtual char *GetErrorString();
	//standart
	virtual Boolean FieldByName( WORD*, char* );
	virtual Boolean KeyByName( WORD*, char* );
	virtual Boolean NameByField( char*, WORD, WORD );
	virtual Boolean NameByKey( char*, WORD, WORD );
	virtual Boolean GetFieldDescriptor( FieldDescriptor*, WORD );
	virtual Boolean GetRecordLen( WORD* );
	virtual Boolean Open( char* );
	virtual Boolean Create( char* );
	virtual Boolean Close();
	virtual Boolean SetFirst( WORD n=0 ) { return SetAfter( 0, n, 0 ); }
	virtual Boolean SetLast( WORD n=0 ) { return SetBefore( 0, n, 0 ); }
	virtual Boolean SetBefore( void* recbuf, WORD key, DWORD rec=0 )
			{ return SetKey( key, 1, recbuf, rec ); }
	virtual Boolean SetAfter( void* recbuf, WORD key, DWORD rec=0 )
			{ return SetKey( key, 0, recbuf, rec ); }
	virtual Boolean Get( void* recbuf, DWORD, WORD = 0 );
	virtual Boolean Next( void* buf ) { return GetSeq( buf, 0 ); }
	virtual Boolean Previous( void* buf ) { return GetSeq( buf, 1 ); }
	virtual Boolean Add( void* );
	virtual Boolean Put( void* );
	virtual Boolean Delete();
	virtual Boolean GetKeyDescriptor( KeyDescriptor*, WORD );
	virtual Boolean GetFileDescriptor( FileDescriptor* );
	virtual Boolean FieldCount( WORD* );
	virtual Boolean KeyCount( WORD* );
	virtual Boolean GetMemo( void*, WORD, void* );
	virtual Boolean SetMemo( void*, WORD, void* );
protected:
private:
	friend TClaField;
	uint4 nRand, nSeq; // last records
	cla_filedescr* pd;
	void* keybuf;
	int2 ClaErr;
	int2 nKey;
	int2 direction; // 0 - forward, 1 - backward
	int2 access;    // 0 - seq, 1 - random

	uint4& LastRecord() { return access ? nRand : nSeq; }
	int2 KeyLen( int2 );
	Boolean ErrEncode();
	Boolean SetKey( int2 key, int2 dir, void* recbuf, uint4 rec );
	Boolean Get( int2 key, void* keybuf, void* recbuf, uint4* rec, int2 action );
	Boolean GetSeq( void* recbuf, int2 dir ); // dir: 0-next, 1-prev
};
