#ifndef __CLA_DAT_H
#define __CLA_DAT_H
#include <fix_type.h>
#ifdef __cplusplus
  extern "C" {
#endif
/*
 Function & structures to deal with Clarion'd dates & times
 Algorithms used here are based on those contained in 'dat.c' and 'dat.h',
 however besause of Clarion originally use it's own, less smart algorithm,
 I don't shure for exact date it is valid from.
 Formally Clarion's date representation require encoded date to be
 >=4 and <109211, which values corresponded to 1/1/1801 and about ?/?/2097
 */
typedef struct str_cla_date {
	int2 year;
	int2 month;
	int2 day;
} cla_date;
typedef cla_date* pcla_date;

typedef struct str_cla_time {
	int2 hour;
	int2 min;
	int2 sec;
	int2 hundreds;
} cla_time;
typedef cla_time* pcla_time;

/* make absolute date from parts */
int2 cla_date_encode( pcla_date, uint4* );
/* break absolute date into parts */
int2 cla_date_decode( pcla_date, uint4 );

/* make absolute time from parts */
int2 cla_time_encode( pcla_time, int4* );
/* break absolute date into parts */
int2 cla_time_decode( pcla_time, int4 );

#ifdef __cplusplus
  }
#endif
#endif /* __CLA_DAT_H */
