#ifndef __CLA_ERR_H
#define __CLA_ERR_H
#include <fix_type.h>
#ifdef __cplusplus
  extern "C" {
#endif

#define ERR_NONE ((int2)(0))
#define ERR_UNDEFINED ((int2)(-1))
#define ERR_INVALID_DATE ((int2)(1))
#define ERR_INVALID_TIME ((int2)(2))
#define ERR_INVALID_POINTER ((int2)(3))
#define ERR_READ ((int2)(4))
#define ERR_LOCK_FAIL ((int2)(5))
#define ERR_UNLOCK_FAIL ((int2)(6))
#define ERR_MEM ((int2)(7))
#define ERR_OPEN ((int2)(8))
#define ERR_CLOSE ((int2)(9))
#define ERR_NOT_FOUND ((int2)(10))
#define ERR_ACCESS ((int2)(11))
#define ERR_WRITE ((int2)(12))
#define ERR_DELETED ((int2)(13))
#define ERR_TOO_SMALL ((int2)(14))
#define ERR_FILE_CORRUPTED ((int2)(15))
#define ERR_LOCKED ((int2)(16))
#define ERR_KEYVIOL ((int2)(17))
/* fill 's' with string corresponded to 'err', 'len' is size of 's'
 's' is always 0 - terminated, however, it may contain only part of string
 return - size of string required
 */
int2 cla_errstring( int2 err, int1* s, int2 len );

#ifdef __cplusplus
  }
#endif
#endif /* __CLA_ERR_H */
