#include <string.h>
#include <cla_file.h>
#include <cla_err.h>
/*---------------------------------------
int2 cla_fldtype( pcla_filedescr pd, int2 n, int1* pch );
int2 cla_fldget( pcla_filedescr pd, int2 n, void* buf, void* addr );
int2 cla_fldput( pcla_filedescr pd, int2 n, void* buf, void* addr );
 ----------------------------------------*/
static int1* ftype[]={
	"LONG",
	"REAL",
	"STRING",
	"PICT",
	"BYTE",
	"SHORT",
	"GROUP",
	"DECIMAL"
};

int2 cla_fldtype( pcla_filedescr pd, int2 n, int1* pch ) {
	if ( pd && pch && pd->hdr ) {
		pcla_hdr_field pf=( n>0 && n<=pd->hdr->numflds ) ? &pd->hdr_field[n-1] : 0;
		if ( pf ) {
			strcpy( pch, ftype[pf->fldtype-1] );
			return ERR_NONE;
		} else return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}

int2 cla_fldget( pcla_filedescr pd, int2 n, void* buf, void* addr ) {
	if ( pd && buf && addr ) {
		if ( pd->hdr && n>0 && n<=pd->hdr->numflds ) {
			pcla_hdr_field pf=&pd->hdr_field[n-1];
			memcpy( addr, (int1*)buf+sizeof( cla_hdr_rec )+pf->foffset, pf->length );
			return ERR_NONE;
		} else return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}

int2 cla_fldput( pcla_filedescr pd, int2 n, void* buf, void* addr ) {
	if ( pd && buf && addr ) {
		if ( pd->hdr && n>0 && n<=pd->hdr->numflds ) {
			pcla_hdr_field pf=&pd->hdr_field[n-1];
			memcpy( (int1*)buf+sizeof( cla_hdr_rec )+pf->foffset, addr, pf->length );
			return ERR_NONE;
		} else return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}
