#include <cla_file.h>
#include <cla_err.h>
/*--------------------------------------------
int2 cla_recbufsize( pcla_filedescr pd, uint2* pn );
int2 cla_keycount( pcla_filedescr pd, int2* pn );
int2 cla_fldcount( pcla_filedescr pd, int2* pn );
int2 cla_keysize( pcla_filedescr pd, int2 n, int2* psz );
int2 cla_setkey( pcla_filedescr pd, int2 nkey );
 ---------------------------------------------*/
/*-----------information functions----------------*/
int2 cla_recbufsize( pcla_filedescr pd, uint2* pn ) {
	if ( pd && pn ) {
		if ( pd->hdr ) {
			*pn=pd->hdr->reclen;
			return ERR_NONE;
		} else return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}

int2 cla_keycount( pcla_filedescr pd, int2* pn ) {
	if ( pd && pn ) {
		if ( pd->hdr ) {
			*pn=(int2)pd->hdr->numbkeys;
			return ERR_NONE;
		} else return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}

int2 cla_fldcount( pcla_filedescr pd, int2* pn ) {
	if ( pd && pn ) {
		if ( pd->hdr ) {
			*pn=(int2)pd->hdr->numflds;
			return ERR_NONE;
		} else return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}

int2 cla_keysize( pcla_filedescr pd, int2 n, int2* psz ) {
	if ( pd && psz ) {
		if ( pd->keys ) {
			if ( n==-1 ) n=pd->current_key;
			if ( n>0 && n<=pd->hdr->numbkeys ) {
				*psz=pd->keys[n-1].keysect->complen;
				return ERR_NONE;
			} else return ERR_NOT_FOUND;
		} else return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}

/*---------------Auxilary functions-----------------*/
int2 cla_setkey( pcla_filedescr pd, int2 nkey ) {
	if ( pd ) {
		if ( pd->hdr && nkey>=0 && nkey<=pd->hdr->numbkeys ) {
			pd->current_key=nkey;
			return ERR_NONE;
		} else return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}

