#include <cla_file.h>
#include <cla_str.h>
#include <cla_err.h>

static void cla_strip( int1** ppname, int1* plen, int1 c ) {
	int1* ptr=*ppname;
	int1 i=*plen;
	while ( (--i)>0 && (*ptr++)!=c ) ;
	if ( i ) {
		*plen=i;
		*ppname=ptr;
	}
}

int2 cla_keyname( pcla_filedescr pd, int2 n, int1* pch, int2 len ) {
	if ( pd && pd->hdr && pch && pd->keys && len>0
			&& n>0 && n<=pd->hdr->numbkeys ) {
			int1* pname=pd->keys[n-1].keysect->keynams;
			int1 len1=16;
			cla_strip( &pname, &len1, ':' );
			cla_strcpy( pch, pname, len<=len1 ? len-1 : len1 );
			return cla_strlen( pname, len1 )<len ? ERR_NONE : ERR_TOO_SMALL;
	} else return ERR_INVALID_POINTER;
}

int2 cla_keynum( pcla_filedescr pd, int1* pch, int2* pn ) {
	if ( pd && pd->hdr && pch && pn ) {
		int2 k=0, k1=(int2)pd->hdr->numbkeys;
		for ( ;k<k1;k++ ) {
			int1* pname= pd->keys[k].keysect->keynams;
			int1 len=16;
			cla_strip( &pname, &len, ':' );
			if ( 0==cla_strcmp1( pch, pname, len ) ) {
				*pn=k+1;
				return ERR_NONE;
			}
		}
		return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}

int2 cla_fldname( pcla_filedescr pd, int2 n, int1* pch, int2 len ) {
	if ( pd && pch && pd->hdr ) {
		pcla_hdr_field pf=( n>0 && n<=pd->hdr->numflds ) ? &pd->hdr_field[n-1] : 0;
		if ( pf ) {
			int1* pname=pf->fldname;
			int1 len1=16;
			cla_strip( &pname, &len1, ':' );
			cla_strcpy( pch, pname, len<=len1 ? len-1 : len1 );
			return cla_strlen( pname, len1 )<len ? ERR_NONE : ERR_TOO_SMALL;
		} else return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}

int2 cla_fldnum( pcla_filedescr pd, int1* pch, int2* pn ) {
	if ( pd && pch && pn ) {
		int2 n=0;
		for ( ; n<pd->hdr->numflds; n++ ) {
			int1* pname=pd->hdr_field[n].fldname;
			int1 len=16;
			cla_strip( &pname, &len, ':' );
			if ( 0==cla_strcmp1( pch, pname, len ) ) {
				*pn=n+1;
				return ERR_NONE;
			}
		}
		return ERR_NOT_FOUND;
	} else return ERR_INVALID_POINTER;
}