/*#define DEBUG_KEYNODE*/
#ifdef __OS2__
#include <string.h>
#include <malloc.h>
#else /* ! __OS2__ */
#include <mem.h>
#include <alloc.h>
#endif /* __OS2__ */
#ifdef DEBUG_KEYNODE
#include <stdio.h>
#endif /* DEBUG_KEYNODE */
#include <key_util.h>
#include <cla_key.h>
#include <cla_err.h>
/* Insert/Delete */
/*--------------------------------------------------------
 int2 key_insert( int hf, void* buf, uint4 rec );
 int2 key_delete( int hf, void* buf, uint4 rec );
 --------------------------------------------------------*/
/* number of node to insert:
 if free chain exist, their head,
 else append new node */
#define KEY_ENTRY( pnode, ph, i ) ((pkey_entry)&(((int1*)(&(pnode)[1]))[(i)*(ph)->keylen]))

static int2 key_newnode( int hf, pkey_hdr ph, pkey_node pnode, uint4* prec ) {
	uint4 rec=ph->unused;
	int2 err=0;
	if ( rec ) {
		if ( 0==(err=key_getnode( hf, rec, pnode )) ) {
			ph->unused=pnode->flink;
		}
	} else {
		ph->numnode++;
		rec=ph->numnode;
	}
	memset( pnode, 0, sizeof( key_node ) );
	*prec=rec;
	return err;
}

typedef struct str_descr_insert {
	int hf;
	int2 lvl;
	pkey_hdr ph;
	pkey_node pnode;
	uint4 nn;
	uint4 rec;
	void* buf;
	uint4 nextrec;
} descr_insert;
typedef descr_insert* pdescr_insert;

/*-----------------01-22-96 11:54am-----------------
 node split

 ************** 0..i-1          =i
 *   ********** i..keynode-1    =keynode-i
 a...ac...c + B ===>

 a...aBc...c
 *   ********** i+1..keynode
 *   ********** i
 ************** 0..i-1

---------------------------------------------------*/

static int2 key_insbefore( pdescr_insert pins ) {
	int2 i=0;
	int2 err=0;
	/* where to add ? */
	{
		/*int2 cmp=0;*/
		while ( i<pins->pnode->keycnt ) {
			pkey_entry pe=(pkey_entry)&(((int1*)(&pins->pnode[1]))[i*pins->ph->keylen]);
			if ( pe->relrec==pins->nextrec ) break;
/*
			cmp=memcmp( pe->key, pins->buf, pins->ph->keylen-4 );
			if ( pins->lvl==pins->ph->numlvls && cmp==0 ) {
				cmp=pe->relrec>pins->rec ? 1 : pe->relrec<pins->rec ? -1 : 0;
			}
			if ( cmp>0 ) break;
 */
			i++;
		}
#ifdef DEBUG_KEYNODE
		printf( "\nInsertBefore\t:%ld ------> %ld[%d] (%d)", pins->rec, pins->nn, i, cmp );
#endif /* DEBUG_KEYNODE */
	}
	if ( pins->pnode->keycnt<pins->ph->keynode ) { /* just add */
		pkey_entry pe=KEY_ENTRY(pins->pnode, pins->ph, i );
		memmove( ((int1*)pe)+pins->ph->keylen, pe, (pins->pnode->keycnt-i)*pins->ph->keylen );
		memcpy( pe->key, pins->buf, pins->ph->keylen-4 );
		pe->relrec=pins->rec;
		pins->pnode->keycnt++;
		err=key_putnode( pins->hf, pins->nn, pins->pnode );
	} else { /* split */
		/* make new node from first i1 elements, keep rest */
		int2 i1=pins->ph->keynode/2+1, kl=pins->ph->keylen;
		pkey_node pnode1=(pkey_node)malloc( sz_node );
		uint4 n1=0;
		err=key_newnode( pins->hf, pins->ph, pnode1, &n1 );
		pnode1->keycnt=i1;
		pins->pnode->keycnt=pins->ph->keynode+1-i1;
		/* links */
		pnode1->blink=pins->pnode->blink;
		pnode1->ulink=pins->pnode->ulink;
		pnode1->flink=pins->nn;
		pins->pnode->blink=n1;
		/* elements */
		if ( !err ) {
			int1* dst=(int1*)&pnode1[1], *src=(int1*)&(pins->pnode[1]);
			int2 ii=i<i1 ? i : i1; /* elements to copy */
			memcpy( dst, src, ii*kl );
			src+=ii*kl;
			if ( i<i1 ) {
				dst+=ii*kl;
				memcpy( ((pkey_entry)dst)->key, pins->buf, kl-4 );
				((pkey_entry)dst)->relrec=pins->rec;
				dst+=kl;
				ii=i1-i-1;
				memcpy( dst, src, ii*kl );
				src+=ii*kl;
				dst=(int1*)&pins->pnode[1];
				ii=pins->pnode->keycnt;
			} else {
				dst=(int1*)&pins->pnode[1];
				ii=i-i1;
				memmove( dst, src, ii*kl );
				src+=ii*kl;
				dst+=ii*kl;
				memcpy( ((pkey_entry)dst)->key, pins->buf, kl-4 );
				((pkey_entry)dst)->relrec=pins->rec;
				dst+=kl;
				ii=pins->ph->keynode-i;
			}
			memmove( dst, src, ii*kl );
		}
		/* nodes ready */
		if ( !err ) err=key_putnode( pins->hf, pins->nn, pins->pnode );
		if ( !err ) err=key_putnode( pins->hf, n1, pnode1 );
		/* change, if any, link from prev. node */
		if ( !err && pnode1->blink ) {
			uint4 prev=pnode1->blink;
			pkey_node pnode2=(pkey_node)malloc( sz_node );
			err=key_getnode( pins->hf, prev, pnode2 );
			if ( !err ) {
				pnode2->flink=n1;
				err=key_putnode( pins->hf, prev, pnode2 );
			}
			free( pnode2 );
		}
		/* set new parent for new node's childs */
		if ( !err && pins->lvl<pins->ph->numlvls ) {
			err=key_updatechilds( pins->hf, pnode1, n1, pins->ph->keylen, 0, -1 );
/*
			if ( !err ) {
				err=key_updatechilds( pins->hf, pins->pnode, pins->nn, pins->ph->keylen );
			}
*/
		}
		pins->lvl--;
		/* add new element to parent */
		memcpy( pins->buf, ((pkey_entry)&(((int1*)(&pnode1[1]))[(pnode1->keycnt-1)*kl]))->key, kl-4 );
		pins->rec=n1;
		pins->nextrec=pins->nn;
		/* find parent */
		if ( pins->lvl ) {
			/* prepare add element structure */
			err=key_getnode( pins->hf, pins->nn=pins->pnode->ulink, pins->pnode );
			if ( !err ) {
				err=key_insbefore( pins );
			}
		} else { /* new root with 2 childs : pnode & pnode1 */
#ifdef DEBUG_KEYNODE
			printf( "\t<<Root>>" );
#endif /* DEBUG_KEYNODE */
			err=key_newnode( pins->hf, pins->ph, pnode1, &pins->ph->root );
			if ( !err ) {
				pkey_entry pe=(pkey_entry)&pnode1[1];
				pins->ph->numlvls++;

				memset( pnode1, 0, sizeof( key_node ) );
				pnode1->keycnt=2;
				pe->relrec=pins->rec;
				memcpy( pe->key, pins->buf, kl-4 );
				pe=KEY_ENTRY( pnode1, pins->ph, 1 );
				pe->relrec=pins->nn;
				memcpy( pe->key, ((pkey_entry)&(((int1*)(&pins->pnode[1]))[(pins->pnode->keycnt-1)*kl]))->key, kl-4 );
				err=key_putnode( pins->hf, pins->ph->root, pnode1 );
				if ( !err ) err=key_updatechilds( pins->hf, pnode1, pins->ph->root, pins->ph->keylen, 0, -1 );
			} else err=ERR_READ;
		}
		free( pnode1 );
/* this is done in 'key_newnode'
		if ( !err ) {
			pins->ph->numnode++;
		}
*/
	}
	return err;
}

/* insert key 'buf' of record 'rec' into keyfile 'hf' */
int2 key_insert( int hf, void* buf, uint4 rec ) {
		/* keybof, keyeof ??? */
	if ( buf ) {
		pkey_hdr ph=(pkey_hdr)malloc( sizeof( key_hdr ) );
		pkey_node pnode=(pkey_node)malloc( sz_node );
		/* find node to insert new key */
		int2 i=0, cmp=0;
		uint4 nn;
		int2 err=key_gethdr( hf, ph );
		pkey_entry pe=0;
		if ( !err ) err=key_findnode( hf, buf, rec, pnode, &nn, &i, &cmp );
		pe=(KEY_ENTRY( pnode, ph, i ));
#ifdef DEBUG_KEYNODE
		printf( "\n======keyinsert:\trec\t%ld\tnode\t%ld[%d] (%d)", rec, nn, i, cmp );
#endif /* DEBUG_KEYNODE */
		if ( !err && cmp==0 ) { /* should not be */
			err=ERR_UNDEFINED;
		}
		if ( !err && !(ph->keytyp&KEYTYP_DUPSW) && 0==memcmp( buf, pe->key, ph->keylen-4 ) ) {
			err=ERR_KEYVIOL; /* key violation */
		}
		if ( !err ) {
			/*-----------------01-25-96 03:29pm-----------------
			 keybof, keyeof --------???????????
					--------------------------------------------------*/
			descr_insert ins;
			ins.nextrec=cmp<0 ? pe->relrec : 0;
			if ( i<0 || ph->keybof==0
					|| ( cmp<0 && pe->relrec==ph->keybof ) ) {
				ph->keybof=rec;
			}
			if ( cmp>=0 ) {   /* just 1 case - after last element */
				/* change last key in all parents */
				int2 lvl=1;
				ph->keyeof=rec;
				nn=ph->root;
				err=key_getnode( hf, nn, pnode );
				while ( !err && lvl<ph->numlvls ) {
					memcpy( (KEY_ENTRY( pnode, ph, pnode->keycnt-1 ))->key, buf, ph->keylen-4 );
					err=key_putnode( hf, nn, pnode );
					nn=(KEY_ENTRY( pnode, ph, pnode->keycnt-1 ))->relrec;
					if ( !err ) err=key_getnode( hf, nn, pnode );
					lvl++;
				}
			}
			ins.hf=hf;
			ins.ph=ph;
			ins.pnode=pnode;
			ins.nn=nn;
			ins.lvl=ph->numlvls;
			ins.buf=buf;
			ins.rec=rec;
			err=key_insbefore( &ins );
		}
		if ( !err ) {
			/* update header */
			ph->numkent++;
			err=key_puthdr( hf, ph );
		}
		free( pnode );
		free( ph );
		return err;
	} else return ERR_INVALID_POINTER;
}

/* when last element in node was changed,
 this should be reflected in parent node
 Assume that last element in pnode was changed
 contents of pnode is not preserved
 buf - auxilary buffer for key, already contain
 key for last record in node
 */
static int2 key_change( int hf, pkey_hdr ph, pkey_node pnode, uint4 rec, void* buf ) {
	int2 err=0;
	uint4 up=pnode->ulink;
	if ( up ) { /* if parent exist, update it */
		/* save key & record */
		pkey_entry pe=0;
		/*memcpy( buf, pe->key, ph->keylen-4 );*/
		err=key_getnode( hf, up, pnode );
		if ( !err ) {
			int2 i=0;
			for ( ; i<pnode->keycnt; i++ ) {
				pe=KEY_ENTRY( pnode, ph, i );
				if ( pe->relrec==rec ) break;
			}
			if ( i<pnode->keycnt ) {
				memcpy( pe->key, buf, ph->keylen-4 );
				err=key_putnode( hf, up, pnode );
				if ( !err ) {
					if ( i==pnode->keycnt-1 ) {
						err=key_change( hf, ph, pnode, up, buf );
					}
				}
			} else err=ERR_NOT_FOUND;
		}
	}
	return err;
}

/* delete
 record 'rec'
 from node 'pnode' number 'nn' */
typedef struct str_descr_delete {
	int hf;
	int2 lvl;
	pkey_hdr ph;
	pkey_node pnode;
	uint4 nn;
	uint4 rec;
} descr_delete;
typedef descr_delete* pdescr_delete;

static int2 key_delete1( pdescr_delete pdel );
static int2 key_freenode( pdescr_delete pdel ) {
	int2 err=0;
	uint4 blink=pdel->pnode->blink,
								flink=pdel->pnode->flink,
								ulink=pdel->pnode->ulink;
	memset( pdel->pnode, 0, sizeof( key_node ) );
	pdel->pnode->flink=pdel->ph->unused;
	err=key_putnode( pdel->hf, pdel->nn, pdel->pnode );
	if ( !err ) {
 		pdel->ph->unused=pdel->nn;
		if ( blink ) {
			err=key_getnode( pdel->hf, blink, pdel->pnode );
			pdel->pnode->flink=flink;
			if ( !err ) {
				err=key_putnode( pdel->hf, blink, pdel->pnode );
			}
		}
		if ( !err && flink ) {
			err=key_getnode( pdel->hf, flink, pdel->pnode );
			pdel->pnode->blink=blink;
			if ( !err ) {
				err=key_putnode( pdel->hf, flink, pdel->pnode );
			}
		}
		if ( !err && ulink ) { /* delete from parent, if any */
			pdel->rec=pdel->nn;
			err=key_getnode( pdel->hf, pdel->nn=ulink, pdel->pnode );
			if ( !err ) {
				pdel->lvl--;
				err=key_delete1( pdel );
			}
		}
	}
	return err;
}
/* merge nodes
	 (n1, pnode1) + (n2, pnode2)
 is_last indicates wether last entry from pnode2 was deleted

 if one of nodes should be deleted, it is always pnode1
 */


static int2 key_merge( pdescr_delete pdel, uint4 n1, pkey_node pnode1, uint4 n2, pkey_node pnode2, int2 is_last ) {
	int2 total=pnode1->keycnt+pnode2->keycnt;
	int2 kl=pdel->ph->keylen;
	int2 err=0;
	if ( total>pdel->ph->keynode ) { /* keep both nodes, redistribute elements */
		int2 i1=total/2; /* why not ? */
		int2 i2=total-i1;
		/* direction ? */
		if ( i1<pnode1->keycnt ) { /* 1 ===> 2 */
/*
		<i1 ><   >   <   >      <i1 >   <   i2   >
		1...1x...x + 2...2 ===> 1...1 + x...x2...2
*/
			int1* ptr2=(int1*)&pnode2[1];
			int1* ptr1=(int1*)KEY_ENTRY( pnode1, pdel->ph, i1 );
			memmove( &ptr2[i1*kl], ptr2, pnode2->keycnt*kl );
			memcpy( ptr2, ptr1, (pnode1->keycnt-i1)*kl );
		} else { /* 2 ===> 1 */
/*
		<   >   <   ><i2 >      <   i1   >   <i2 >
		1...1 + x...x2...2 ===> 1...1x...x + 2...2
*/
			int1* ptr1=(int1*)KEY_ENTRY( pnode1, pdel->ph, pnode1->keycnt );
			int1* ptr2=(int1*)&pnode2[1];
			memcpy( ptr1, ptr2, (pnode2->keycnt-i2)*kl );
			memmove( ptr2, &ptr2[(pnode2->keycnt-i2)*kl], i2*kl );
		}
		pnode1->keycnt=i1;
		pnode2->keycnt=i2;
		/* nodes itself ready */
		err=key_putnode( pdel->hf, n1, pnode1 );
		if ( !err ) err=key_putnode( pdel->hf, n2, pnode2 );
		/* update childs */
		if ( pdel->lvl<pdel->ph->numlvls ) { /* change '==' to '<' */
			if ( !err ) err=key_updatechilds( pdel->hf, pnode1, n1, kl, 0, -1 );
			if ( !err ) err=key_updatechilds( pdel->hf, pnode2, n2, kl, 0, -1 );
		}
		/* update keys in parent */
		if( !err ) {
			int2 kl=pdel->ph->keylen-4;
			void* buf=malloc( kl );
			pkey_entry pe=KEY_ENTRY( pnode1, pdel->ph, pnode1->keycnt-1 );
			memcpy( buf, pe->key, kl );
			err=key_change( pdel->hf, pdel->ph, pnode1, n1, buf );
			if ( !err && is_last ) {
				pe=KEY_ENTRY( pnode2, pdel->ph, pnode2->keycnt-1 );
				memcpy( buf, pe->key, kl );
				err=key_change( pdel->hf, pdel->ph, pnode2, n2, buf );
			}
			free( buf );
		}
	} else { /* collect all elements in pnode2, free pnode1, delete them from parent */
		/*uint4 up=pnode1->ulink;*/
		int1* ptr=(int1*)&pnode2[1];
		memmove( &ptr[kl*pnode1->keycnt], ptr, kl*pnode2->keycnt );
		memcpy( ptr, &pnode1[1], kl*pnode1->keycnt );
		pnode2->keycnt=total;
		err=key_putnode( pdel->hf, n2, pnode2 );
		if ( !err ) {
			/* update childs for first pnode1->keycnt elements
			 now update all, it is not necessary */
			if ( pdel->lvl<pdel->ph->numlvls ) {  /* change '==' to '<' */
				err=key_updatechilds( pdel->hf, pnode2, n2, pdel->ph->keylen, 0, -1 );
			}
			if ( !err ) {
				pdel->pnode=pnode1;
				pdel->nn=n1;
				err=key_freenode( pdel );
				if ( !err && is_last ) { /* last element was deleted */
					pkey_entry pe=KEY_ENTRY( pnode2, pdel->ph, pnode2->keycnt-1 );
					int2 kl=pdel->ph->keylen-4;
					void* buf=malloc( kl );
					memcpy( buf, pe->key, kl );
					err=key_change( pdel->hf, pdel->ph, pnode2, n2, buf );
					free( buf );
				}
			}
		}
	}
	return err;
}

static int2 key_delete1( pdescr_delete pdel ) {
	int2 err=0;
	int2 i=0;
	pkey_entry pe=0;
	for ( ; i<pdel->pnode->keycnt; i++ ) {
		pe=KEY_ENTRY( pdel->pnode, pdel->ph, i );
		if ( pe->relrec==pdel->rec ) break;
	}
	if ( i<pdel->pnode->keycnt ) {
		int2 i1=pdel->ph->keynode/2;
		uint4 up=pdel->pnode->ulink;
		pdel->pnode->keycnt--;
		memmove( pe, ((int1*)pe)+pdel->ph->keylen, (pdel->pnode->keycnt-i)*pdel->ph->keylen );
		if ( pdel->pnode->keycnt<( up ? i1 : 2 ) ) {
			if ( up ) {
				if ( pdel->pnode->keycnt ) { /* merge */
					int2 is_last=( i==pdel->pnode->keycnt );
				/*==================================================*/
					pkey_node pnode1=(pkey_node)malloc( sz_node );
					if ( pdel->pnode->blink ) {
						err=key_getnode( pdel->hf, pdel->pnode->blink, pnode1 );
						if ( !err ) {
							err=key_merge( pdel, pdel->pnode->blink, pnode1, pdel->nn, pdel->pnode, is_last );
						}
					} else if ( pdel->pnode->flink ) {
						err=key_getnode( pdel->hf, pdel->pnode->flink, pnode1 );
						if ( !err ) {
							err=key_merge( pdel, pdel->nn, pdel->pnode, pdel->pnode->flink, pnode1, 0 );
						}
					} else err=ERR_UNDEFINED;
					free( pnode1 );
				/*==================================================*/
				} else { /* empty node, delete them from parent & free node itself */
					err=key_freenode( pdel );
				}
			} else if ( pdel->ph->numlvls>1 ) { /* delete root */
				pe=KEY_ENTRY( pdel->pnode, pdel->ph, 0 );
				pdel->ph->root=pe->relrec;
				pdel->ph->numlvls--;
				err=key_freenode( pdel );
			} else {  /* just root, nothing to delete ( always keep root ) */
				err=key_putnode( pdel->hf, pdel->nn, pdel->pnode );
			}
		} else { /* node is OK, no merge required */
			err=key_putnode( pdel->hf, pdel->nn, pdel->pnode );
			if ( !err && i==pdel->pnode->keycnt ) { /* last element was deleted */
				int2 kl=pdel->ph->keylen-4;
				void* buf=malloc( kl );
				pe=KEY_ENTRY( pdel->pnode, pdel->ph, i-1 );
				memcpy( buf, pe->key, kl );
				err=key_change( pdel->hf, pdel->ph, pdel->pnode, pdel->nn, buf );
				free( buf );
			}
		}
	} else err=ERR_NOT_FOUND;
	return err;
}

/* delete key 'buf' of record 'rec' from keyfile 'hf' */
int2 key_delete( int hf, void* buf, uint4 rec ) {
		/* keybof, keyeof ??? */
	if ( buf ) {
		pkey_hdr ph=(pkey_hdr)malloc( sizeof( key_hdr ) );
		pkey_node pnode=(pkey_node)malloc( sz_node );
		/* find node to delete key from */
		int2 i=0, cmp=0;
		uint4 nn;
		int2 err=key_gethdr( hf, ph );
		if ( !err ) err=key_findnode( hf, buf, rec, pnode, &nn, &i, &cmp );
		if ( !err && cmp==0 ) {
			if ( rec==ph->keybof ) {
				if ( pnode->keycnt>1 ) ph->keybof=KEY_ENTRY( pnode, ph, 1 )->relrec;
				else if ( pnode->flink ) {
					pkey_node pnode1=(pkey_node)malloc( sz_node );
					err=key_getnode( hf, pnode->flink, pnode1 );
					if ( !err ) ph->keybof=KEY_ENTRY( pnode1, ph, 0 )->relrec;
					free( pnode1 );
				} else ph->keybof=0;
			}
			if ( !err && rec==ph->keyeof ) {
				if ( pnode->keycnt>1 ) ph->keyeof=KEY_ENTRY( pnode, ph, pnode->keycnt-2 )->relrec;
				else if ( pnode ->blink ) {
					pkey_node pnode1=(pkey_node)malloc( sz_node );
					err=key_getnode( hf, pnode->blink, pnode1 );
					if ( !err ) ph->keyeof=KEY_ENTRY( pnode1, ph, pnode->keycnt-1 )->relrec;
					free( pnode1 );
				} else ph->keybof=0;
			}
			if ( !err ) {
				descr_delete del;
				del.hf=hf;
				del.ph=ph;
				del.pnode=pnode;
				del.lvl=ph->numlvls;
				del.rec=rec;
				del.nn=nn;
				err=key_delete1( &del );
			}
		} else err=ERR_NOT_FOUND;
		if ( !err ) {
			/* update header */
			ph->numkent--;
			err=key_puthdr( hf, ph );
		}
		free( pnode );
		free( ph );
		return err;
	} else return ERR_INVALID_POINTER;
}
