#ifndef __CLA_MEM__H
#define __CLA_MEM__H
#include <fix_type.h>
#ifdef __cplusplus
  extern "C" {
#endif
/* cla_memget : get memo & cla_memset : set memo
  hf - memo file handle;
  rptr - from record header;
  sz - size of buffer;
  buf - buffer;
---------get-----------
get memo corresponded to 'rptr'
copy up to 'sz' bytes into 'buf'
if 'sz' and 'buf' set to 0, quiery memo size and put them
in 'sz'
---------set-----------
if 'rptr' <>0, change given memo, otherwise add new one.
because of 'rptr' may be changed, new value is returned in the
same 'rptr'.
if 'sz' and 'buf' is 0, memo will be deleted and 'rptr' set to 0
*/
int2 cla_memget( int hf, uint4 rptr, uint4* sz, void* buf );
int2 cla_memset( int hf, uint4* rptr, uint4 sz, void* buf );

#ifdef __cplusplus
  }
#endif
#endif /* __CLA_MEM__H */
