#include <cla_str.h>
#include <ctype.h>

int2 cla_strlen( int1* s, int2 maxlen ) {
	int2 i=0, len=0;
	/* strip leading spaces */
	while ( s[i]<=' ' && i<maxlen ) i++;
	len=(int2)(maxlen-i);
	while ( s[i+len-1]<=' ' && len>0 ) len--;
	return len;
}
/* copy from clarion string to 0-term */
int1* cla_strcpy( int1* dest, int1* src, int2 maxlen ) {
	int2 i=0;
	int1* dst=dest;
	while ( src[i]<=' ' && i<maxlen ) i++;
	while ( src[maxlen-1]<=' ' && maxlen>i ) maxlen--;
	while ( i<maxlen ) *dst++=src[i++];
	*dst='\0';
	return dest;
}
/* copy from 0-term string to clarion */
int1* cla_strcpy1( int1* dest, int1* src, int2 maxlen ) {
	int2 i=0;
	while ( *src && i<maxlen ) dest[i++]=*src++;
	while ( i<maxlen ) dest[i++]=' ';
	return dest;
}

int2 cla_strcmp( int1* s1, int2 l1, int1* s2, int2 l2 ) {
	int2 i1=0, i2=0;
	while ( s1[i1]<=' ' && i1<l1 ) i1++;
	while ( s1[l1-1]<=' ' && l1>i1 ) l1--;
	while ( s2[i2]<=' ' && i2<l2 ) i2++;
	while ( s2[l2-1]<=' ' && l2>i2 ) l2--;
	while ( i1<l1 && i2<l2 ) {
		int2 d=(int2)(toupper(s1[i1++])-toupper(s2[i2++]));
		if ( d ) return d;
	}
	return (int2)(i1<l1 ? toupper(s1[i1])-' ' : i2<l2 ? ' '-toupper(s2[i2]) : 0);
}

int2 cla_strcmp1( int1* s1, int1* s2, int2 l2 ) {
	int2 i2=0;
	while ( s2[i2]<=' ' && i2<l2 ) i2++;
	while ( s2[l2-1]<=' ' && l2>i2 ) l2--;
	while ( *s1 && i2<l2 ) {
		int2 d=(int2)(toupper(*s1++)-toupper(s2[i2++]));
		if ( d ) return d;
	}
	return (int2)(*s1 ? toupper(*s1)-' ' : i2<l2 ? ' '-toupper(s2[i2]) : 0);
}
