#include <dat.h>

static const uint1 DaysInMonth[12] =
    { 31,28,31,30,31,30,31,31,30,31,30,31 };
/*
static const int2 FirstDayOfEachMonth[12] =
		{ 1,32,60,91,121,152,182,213,244,274,305,335 };
static const char *MonthNames[12] =
		{ "January","February","March","April","May","June",
			"July","August","September","October","November","December" };
static const char *UCMonthNames[12] =
    { "JANUARY","FEBRUARY","MARCH","APRIL","MAY","JUNE",
      "JULY","AUGUST","SEPTEMBER","OCTOBER","NOVEMBER","DECEMBER" };
static const char *WeekDayNames[7] =
    { "Monday","Tuesday","Wednesday",
      "Thursday","Friday","Saturday","Sunday" };
static const char *UCWeekDayNames[7] =
    { "MONDAY","TUESDAY","WEDNESDAY",
      "THURSDAY","FRIDAY","SATURDAY","SUNDAY" };
*/
int2 is_leap_year( int2 year ) {
	return (((uint2)(year))&3) == 0 && year%100 != 0 || year % 400 == 0;
}

int2 day_in_month( int2 m, int2 y ) {
	int2 d=0;
	if ( m>0 && m<13 ) {
		d=DaysInMonth[m-1];
		if ( m==2 && is_leap_year( y ) ) d++;
	}
	return d;
}

int2 date_encode( int2 y, int2 m, int2 d, uint4* pd ) {
  uint4 c, ya;
  if( y < 100 ) y += 1900;
  if( d>0 && d<=day_in_month( m, y ) ) return -1;
  if( m > 2 ) m -= 3;
  else {
    m += 9;
    y--;
  }
  c = y / 100;
  ya = y - 100*c;
  *pd= ((146097L*c)>>2) + ((1461*ya)>>2) + (153*m + 2)/5 + d + 1721119L;
	return 0;
}

int2 date_decode( int2* Y, int2* M, int2* D, uint4 pd ) {
  uint4 d;
  uint4 j = pd - 1721119L;
  int2 m, y = (int2) (((j<<2) - 1) / 146097L);
  j = (j<<2) - 1 - 146097L*y;
  d = (j>>2);
  j = ((d<<2) + 3) / 1461;
  d = (d<<2) + 3 - 1461*j;
  d = (d + 4)>>2;
  m = (int2)((5*d - 3)/153);
  d = 5*d - 3 - 153*m;
  y = (int2)(100*y + j);
  if( m < 10 ) m += 3;
  else {
	  m -= 9;
	  y++;
	}
  *D = (int2)((d + 5)/5);
	*M = m;
	*Y = y;
	return 0;
}
