#ifndef __DAT_H
#define __DAT_H
#include <fix_type.h>
#ifdef __cplusplus
  extern "C" {
#endif
/*
 Function to operate with dates
 --------------- Notes : -----------------
 month : 1 - Jan
 day   : begining from 1
 if year<100, it considered to be in 20-th century (+1900)
 algorithm used is valid since (15??) ( I don't shure )

 this functions don't check pointers ( in arguments ) validity.
 -------- Date representation ------------
 enconed date stored as 'uint4' - count of days from 1/1/1
 */
/* <>0 if 366 days/year, 0 if 365, check 4-, 100- and 400- th years */
int2 is_leap_year( int2 y );
int2 day_in_month( int2 m, int2 y );
int2 date_encode( int2 y, int2 m, int2 d, uint4* pd );
int2 date_decode( int2* y, int2* m, int2* d, uint4 pd );

#ifdef __cplusplus
  }
#endif
#endif  /* __DAT_H */
