#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "globals.hpp"
#include "list.hpp"

class DRec
    {
    private:
        int fh;
        ERRORS Error;
        DWORD Cur;
        BYTE CurActive;
    protected:
        BYTE *Contents;
        WORD Len;
        BYTE *Header;
    public:
        DRec();
        virtual ~DRec();
        virtual Boolean Open( char* );
        Boolean Create( char*, BYTE*, BYTE*, WORD );
        virtual Boolean Create( char* );
        Boolean Set( DWORD = 0 );
        Boolean Next();
        BYTE *GetContents()                     { return Contents; }
        BYTE *GetHeader()                       { return Header; }
        WORD GetLen()                           { return Len; }
        DWORD Current()                         { return Cur; }
        ERRORS GetError()                       { return Error; }
        Boolean Append();
        Boolean Put();
        Boolean Delete();
        Boolean Clear();
        virtual Boolean Close();
    };

struct PackRec
    {
	DWORD Type;
	DWORD InNumber;
	DWORD OutNumber;
	DWORD RetNumber;
	DWORD AddressFrom;
	DWORD AddressTo;
	DWORD Begin;
	DWORD Len;
    };

class DRecord: public DRec
    {
    private:
    protected:
    public:
        PackRec rec;
        char BlobFile[100];
        DRecord();
        void SetRec( PackRec *r )           { rec = *r; }
		PackRec *GetRec()					{ return &rec; }
        virtual ~DRecord();
        virtual Boolean Create( char* , char* );
    };

class DQueue
    {
    private:
        DRecord dr;
        int BlobFile;
        ERRORS Error;
        BYTE *bf;
        WORD bsz;
    protected:
    public:
        DQueue();
        virtual ~DQueue();
        ERRORS GetError()                       { return Error; }
        void SetBuf( WORD );
        Boolean Open( char* );
        Boolean Close();
        Boolean Create( char*, char* );
        Boolean Append( char*, PackRec* );
        Boolean Delete();
        Boolean Set( DWORD = 0 );
        Boolean Next( PackRec* );
        Boolean Get( char*, PackRec* );
        Boolean ExtructFirst( char*, PackRec* );
        Boolean ExtructOnAddress( DWORD, char*, PackRec* );
    };

class DPack
	{
	private:
		ERRORS Error;
		int fld;
		List<PackRec> lpr;
		List<char> Names;
        BYTE *bf;
        WORD bsz;
		PackRec Signature;
	protected:
	public:
		DPack();
		~DPack();
		ERRORS GetError()					{ return Error; }
        void SetBuf( WORD );
		Boolean Open( char* );
		PackRec *GetSignature()				{ return &Signature; }
		void SetSignature( PackRec *s )		{ Signature = *s; }
		Boolean Close();
		Boolean Create( char* );
		Boolean AddToList( char*, PackRec* );
		void EmptyList()					{ lpr.RemoveAll(); }
		Boolean Pack();
		Boolean Get( DWORD, PackRec* );
		DWORD Records()						{ return lpr.GetCount(); }
		Boolean Extruct( DWORD, char* );
	};