#include "globals.hpp"
#include "clarion.h"


class MnemoID
	{
	private:
		ERRORS Error;
		TClaFile ids;
		BYTE *rec;
		TClaField id;
		TClaField code;
		WORD PrimaryKey;
	protected:
	public:
		ERRORS GetError()					{ return Error; }
		MnemoID( char* );
		virtual ~MnemoID();
		long CodeByID( char* );
	};

class FNames
	{
	private:
		ERRORS Error;
		TClaFile files;
		BYTE *rec;
		TClaField fname;
		TClaField code;
		WORD PrimaryKey;
	protected:
	public:
		ERRORS GetError()					{ return Error; }
		FNames( char* );
		virtual ~FNames();
		Boolean GetFName( long, char*, WORD );
	};

class PhoneBook
	{
	private:
		ERRORS Error;
		TClaFile addresses;
		BYTE *rec;
		TClaField code;
		TClaField name;
		TClaField address;
		WORD PrimaryKey;
	protected:
	public:
		ERRORS GetError()					{ return Error; }
		PhoneBook( char* );
		virtual ~PhoneBook();
		Boolean GetName( long, char*, WORD );
		Boolean GetPostAddress( long, char*, WORD );
	};

class Answer
	{
	private:
		ERRORS Error;
		TClaFile answer;
		BYTE *rec;
		TClaField packet;
		TClaField address;
		WORD AccessKey;
	protected:
	public:
		ERRORS GetError()					{ return Error; }
		Answer( char* );
		virtual ~Answer();
		Boolean ClearAnswer();
		Boolean SetAnswer( long, long );
		Boolean GetAnswer( long&, long& );
	};

class Check
	{
	private:
		ERRORS Error;
		TClaFile checks;
		BYTE *rec;
		TClaField type;
		TClaField OutNumber;
		TClaField address;
		WORD AccessKey;
	protected:
	public:
		ERRORS GetError()					{ return Error; }
		Check( char* );
		virtual ~Check();
		Boolean AddCheck( long, long, long );
		Boolean NextCheck( long, long&, long& );
	};

class Direction
	{
	private:
		ERRORS Error;
		TClaFile direction;
		BYTE *rec;
		TClaField address;
		TClaField InNumber;
		TClaField OutNumber;
		TClaField RetNumber;
		WORD AccessKey;
	protected:
	public:
		ERRORS GetError()		 			{ return Error; }
		Direction( char* );
		virtual ~Direction();
		Boolean GetDirInfo( long, long*, long*, long* );
		Boolean SetDirInfo( long, long, long, long );
	};

class Pc2Fl
	{
	private:
		ERRORS Error;
		TClaFile pac2fil;
		BYTE *rec;
		TClaField packet;
		TClaField file;
		WORD AccessKey;
	protected:
	public:
		ERRORS GetError()		 			{ return Error; }
		Pc2Fl( char* );
		virtual ~Pc2Fl();
		Boolean SetPack( long );
		Boolean NextPack( long& );
	};


class Tasks
	{
	private:
		ERRORS Error;
		TClaFile tasks;
		BYTE *rec;
		TClaField code;
		TClaField value;
		WORD AccessKey;
	protected:
	public:
		ERRORS GetError()		 			{ return Error; }
		Tasks( char* );
		virtual ~Tasks();
		Boolean GetTask( long, char*, WORD );
	};

class Timer
	{
	private:
		ERRORS Error;
		TClaFile timers;
		long ttp;
		BYTE *rec;
		TClaField date;
		TClaField time;
		TClaField type;
		TClaField ldate;
		TClaField odd;
		TClaField contents;
		WORD AccessKey;
	protected:
	public:
		ERRORS GetError()		 			{ return Error; }
		Timer( char* );
		virtual ~Timer();
		Boolean GetEvent( long, BYTE*, WORD );
		Boolean GetHronEvent( long, BYTE*, WORD );
		Boolean AddEvent( long, long, long, BYTE, BYTE*, WORD );
		Boolean SetEvent( long );
		Boolean NextEvent( long*, long*, long*, BYTE*, BYTE*, WORD );
		Boolean ClearEvent();
	};