#include "filters.hpp"
#include "isamfile.hpp"
#include "iostream.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>

//-------------------------------			DBField



DBField::DBField()
	{
	fl = NULL;
	Error = NOERROR;
	memset( &fd, 0, sizeof( FieldDescriptor ) );
	inbf = NULL;
	}

DBField::~DBField()
	{
	if( inbf )
		delete inbf;
	}

Boolean DBField::SetProperty( ISAMFile *f, WORD n )
	{
	fl = f;
	if( !fl->GetFieldDescriptor( &fd, n ) )
		{
		Error = fl->GetError();
		return FALSE;
		}
	if( inbf )
		delete inbf;
	inbf = new BYTE[ fd.Len ];

	Error = NOERROR;
	return TRUE;
	}

Boolean DBField::SetProperty( ISAMFile *f, char *n )
	{
	WORD l;
	fl = f;
	if( !fl->FieldByName( &l, n ) )
		{
		Error = fl->GetError();
		return FALSE;
		}
	if( !fl->GetFieldDescriptor( &fd, l ) )
		{
		Error = fl->GetError();
		return FALSE;
		}
	if( inbf )
		delete inbf;
	inbf = new BYTE[ fd.Len ];
	Error = NOERROR;
	return TRUE;
	}

Boolean DBField::SetAsInt( void *rec, int val )
	{
	char bf[80];
	BYTE b;
	long l;
	short h;
	double d;

	switch( fd.Type )
		{
		case DBBYTE:
			b = val;
			Set( rec, &b );
			break;
		case DBSTRING:
			sprintf( bf, "%d", val );
			UnClip( bf, (char*)inbf, fd.Len );
			Set( rec, inbf );
			break;
		case DBLONG:
			l = val;
			Set( rec, &l );
			break;
		case DBSHORT:
			h = val;
			Set( rec, &h );
			break;
		case DBDECIMAL:
			Double2Dec( (BYTE*)inbf, fd.Len, fd.Precision, val );
			Set( rec, &inbf );
			break;
		case DBREAL:
			d = val;
			Set( rec, &d );
			break;
		case DBMEMO:
			h = val;
			Set( rec, &h );
			break;
		}


	return TRUE;
	}

Boolean DBField::SetAsLong( void *rec, long val )
	{
	char bf[80];
	BYTE b;
	long l;
	short h;
	double d;

	switch( fd.Type )
		{
		case DBBYTE:
			b = val;
			Set( rec, &b );
			break;
		case DBSTRING:
			sprintf( bf, "%ld", val );
			UnClip( bf, (char*)inbf, fd.Len );
			Set( rec, inbf );
			break;
		case DBLONG:
			l = val;
			Set( rec, &l );
			break;
		case DBSHORT:
			h = val;
			Set( rec, &h );
			break;
		case DBDECIMAL:
			Double2Dec( inbf, fd.Len, fd.Precision, val );
			Set( rec, inbf );
			break;
		case DBREAL:
			d = val;
			Set( rec, &d );
			break;
		case DBMEMO:
			l = val;
			memset( inbf, 0, fd.Len );
			memcpy( inbf, &l, sizeof( long ) );
			Set( rec, inbf );
			break;
		}


	return TRUE;
	}

Boolean DBField::SetAsDouble( void *rec, double val )
	{
	char bf[80];
	BYTE b;
	long l;
	short h;
	double d;

	switch( fd.Type )
		{
		case DBBYTE:
			b = val;
			Set( rec, &b );
			break;
		case DBSTRING:
			sprintf( bf, "%f", val );
			UnClip( bf, (char*)inbf, fd.Len );
			Set( rec, inbf );
			break;
		case DBLONG:
			l = val;
			Set( rec, &l );
			break;
		case DBSHORT:
			h = val;
			Set( rec, &h );
			break;
		case DBDECIMAL:
			Double2Dec( inbf, fd.Len, fd.Precision, val );
			Set( rec, inbf );
			break;
		case DBREAL:
			d = val;
			Set( rec, &d );
			break;
		case DBMEMO:
			d = val;
			memset( inbf, 0, fd.Len );
			memcpy( inbf, &d, sizeof( double ) );
			Set( rec, inbf );
			break;
		}


	return TRUE;
	}

Boolean DBField::SetAsString( void *rec, char *val )
	{
	char bf[80];
	BYTE b;
	long l;
	short h;
	double d;

	switch( fd.Type )
		{
		case DBBYTE:
			inbf[0] = val[0];
			Set( rec, inbf );
			break;
		case DBSTRING:
			UnClip( val, (char*)inbf, fd.Len );
			Set( rec, inbf );
			break;
		case DBLONG:
			l = atol( val );
			Set( rec, &l );
			break;
		case DBSHORT:
			h = atoi( val );
			Set( rec, &h );
			break;
		case DBDECIMAL:
			d = atof( val );
			Double2Dec( inbf, fd.Len, fd.Precision, d );
			Set( rec, inbf );
			break;
		case DBREAL:
			d = atof( val );
			Set( rec, &d );
			break;
		case DBMEMO:
			memset( inbf, 0, fd.Len );
			memcpy( inbf, val, fd.Len );
			Set( rec, inbf );
			break;
		}


	return TRUE;
	}

Boolean DBField::SetAsPtr( void *rec, void *val, WORD ln )
	{
	long l;
	short h;
	double d;

	switch( fd.Type )
		{
		case DBBYTE:
			Set( rec, val );
			break;
		case DBSTRING:
			Set( rec, val );
			break;
		case DBLONG:
			l = *((long*)val);
			Set( rec, &l );
			break;
		case DBSHORT:
			h = *((short*)val);
			Set( rec, &h );
			break;
		case DBDECIMAL:
			d = *((double*)val);
			Double2Dec( inbf, fd.Len, fd.Precision, d );
			Set( rec, inbf );
			break;
		case DBREAL:
			d = *((double*)val);
			Set( rec, &d );
			break;
		case DBMEMO:
			Set( rec, val );
			break;
		}


	return TRUE;
	}

Boolean DBField::SetAsByte( void *rec, BYTE val )
	{
	char bf[80];
	double d;
	BYTE b;
	long l;
	short h;

	switch( fd.Type )
		{
		case DBBYTE:
			Set( rec, &val );
			break;
		case DBSTRING:
			sprintf( bf, "%d", val );
			UnClip( bf, (char*)inbf, fd.Len );
			Set( rec, inbf );
			break;
		case DBLONG:
			l = val;
			Set( rec, &l );
			break;
		case DBSHORT:
			h = val;
			Set( rec, &h );
			break;
		case DBDECIMAL:
			Double2Dec( inbf, fd.Len, fd.Precision, val );
			Set( rec, inbf );
			break;
		case DBREAL:
			d = val;
			Set( rec, &d );
			break;
		case DBMEMO:
			Set( rec, &val );
			break;
		}


	return TRUE;
	}

Boolean DBField::GetAsInt( void *rec, int *val )
	{
	char bf[80];

	Get( rec, inbf );
	switch( fd.Type )
		{
		case DBBYTE:
			*val = inbf[0];
			break;
		case DBSTRING:
			Clip( bf, (char*)inbf, fd.Len );
			*val = atoi( bf );
			break;
		case DBLONG:
			*val = *((long*)(inbf));
			break;
		case DBSHORT:
			*val = *((short*)(inbf));
			break;
		case DBDECIMAL:
			*val = Dec2Double( inbf, fd.Len, fd.Precision );
			break;
		case DBREAL:
			*val = *((double*)(inbf));
			break;
		case DBMEMO:
			*val = *((int*)(inbf));
			break;
		}

	return TRUE;
	}

Boolean DBField::GetAsLong( void *rec, long *val )
	{
	char bf[80];

	Get( rec, inbf );
	switch( fd.Type )
		{
		case DBBYTE:
			*val = inbf[0];
			break;
		case DBSTRING:
			Clip( bf, (char*)inbf, fd.Len );
			*val = atol( bf );
			break;
		case DBLONG:
			 *val = *((long*)(inbf));
			break;
		case DBSHORT:
			*val = *((short*)(inbf));
			break;
		case DBDECIMAL:
			*val = Dec2Double( inbf, fd.Len, fd.Precision );
			break;
		case DBREAL:
			*val = *((double*)(inbf));
			break;
		case DBMEMO:
			*val = *((long*)(inbf));
			break;
		}

	return TRUE;
	}

Boolean DBField::GetAsDouble( void *rec, double *val )
	{
	char bf[80];

	Get( rec, inbf );
	switch( fd.Type )
		{
		case DBBYTE:
			*val = inbf[0];
			break;
		case DBSTRING:
			Clip( bf, (char*)inbf, fd.Len );
			*val = atof( bf );
			break;
		case DBLONG:
			 *val = *((long*)(inbf));
			break;
		case DBSHORT:
			*val = *((short*)(inbf));
			break;
		case DBDECIMAL:
			*val = Dec2Double( inbf, fd.Len, fd.Precision );
			break;
		case DBREAL:
			*val = *((double*)(inbf));
			break;
		case DBMEMO:
			*val = *((double*)(inbf));
			break;
		}

	return TRUE;
	}

Boolean DBField::GetAsString( void *rec, char *val, WORD ln )
	{
	char *bf;
	double d;

	bf = new char[ fd.Len + 1 ];
	Get( rec, inbf );
	ln = ( ln > fd.Len )? fd.Len : ln;
	switch( fd.Type )
		{
		case DBBYTE:
			sprintf( bf, "%d", inbf );
			strncpy( val, bf, ln - 1 );
			break;
		case DBSTRING:
			Clip( bf, (char*)inbf, fd.Len );
			strncpy( val, bf, ln - 1 );
			break;
		case DBLONG:
			sprintf( bf, "%ld", *((long*)(inbf)) );
			strncpy( val, bf, ln - 1 );
			break;
		case DBSHORT:
			sprintf( bf, "%d", *((short*)(inbf)) );
			strncpy( val, bf, ln - 1 );
			break;
		case DBDECIMAL:
			sprintf( bf, "%f", Dec2Double( inbf, fd.Len, fd.Precision ) );
			strncpy( val, bf, ln - 1 );
			break;
		case DBREAL:
			sprintf( bf, "%f", *((double*)(&inbf)) );
			strncpy( val, bf, ln - 1 );
			break;
		case DBMEMO:
			strncpy( val, (char*)inbf, ln - 1 );
			break;
		}

	return TRUE;
	}

Boolean DBField::GetAsPtr( void *rec, void *val, WORD ln )
	{
	char bf[80];

	Get( rec, inbf );
	ln = ( ln > fd.Len )? fd.Len : ln;
	switch( fd.Type )
		{
		case DBBYTE:
			((BYTE*)val)[0] = inbf[0];
			break;
		case DBSTRING:
			Clip( bf, (char*)inbf, fd.Len );
			strncpy( (char*)val, bf, ln - 1 );
			break;
		case DBLONG:
		case DBSHORT:
		case DBDECIMAL:
		case DBREAL:
		case DBMEMO:
			memcpy( val, inbf, ln );
			break;
		}

	return TRUE;
	}

Boolean DBField::GetAsByte( void *rec, BYTE *val )
	{
	char bf[80];

	Get( rec, inbf );
	switch( fd.Type )
		{
		case DBBYTE:
			*val = inbf[0];
			break;
		case DBSTRING:
			Clip( bf, (char*)inbf, fd.Len );
			*val = atoi( bf );
			break;
		case DBLONG:
			 *val = *((long*)(inbf));
			break;
		case DBSHORT:
			*val = *((short*)(inbf));
			break;
		case DBDECIMAL:
			*val = Dec2Double( inbf, fd.Len, fd.Precision );
			break;
		case DBREAL:
			*val = *((double*)(inbf));
			break;
		case DBMEMO:
			*val = inbf[0];
			break;
		}

	return TRUE;
	}

//-----------------------------       KeyDescriptor
Boolean KeyDescriptor::SetProperty( ISAMFile *f, WORD n )
	{
	if( !f->GetKeyDescriptor( this, n ) )
		{
//		f->Error = f->GetError();
		return FALSE;
		}
//	Error = NOERROR;
	return TRUE;
	}

//-----------------------------				ISAMFile

ISAMFile::ISAMFile()
	{
	Error = NOERROR;
	SPtr = 0;
	IPtr = 0;
	}

ISAMFile::~ISAMFile()
	{
	}
