#ifndef __KEY_STRU_H
#define __KEY_STRU_H
#include <fix_type.h>
#ifdef __cplusplus
  extern "C" {
#endif

#define KEYTYP_FTYP  (0x0f) /* duplicates */
#define KEYTYP_DUPSW (0x10) /* duplicates */
#define KEYTYP_UPRSW (0x20) /* uppercase */
#define KEYTYP_OPTSW (0x40) /* fill with space */
#define KEYTYP_LOKSW (0x80) /* locked */

typedef struct str_key_hdr {
  uint4 root;       /* number of root node */
  uint4 numkent;    /* number of key entries */
  uint4 numnode;    /* number of node for this index */
  uint4 lastnod;    /* node number of last node */
  uint4 keyeof;     /* record number of end of file */
  uint4 keybof;     /* record number of beg. of file */
  uint4 unused;     /* first unused node of file */
	uint1 keytyp;     /* type of key */
	uint1 keynode;    /* number of keys per node */
	uint1 numcmps;    /* number of components for key */
	uint2      keylen;     /* total length of key entry */
  uint2      numlvls;    /* number of levels */
  int1       cvoid[477];    /* reserved space */
} key_hdr;
typedef key_hdr* pkey_hdr;

typedef struct str_key_node {
  uint1 keycnt;    /* number of keys in this nodes */
  uint4 flink;     /* forward node pointer */
  uint4 blink;     /* backwards node printer */
  uint4 ulink;     /* upwards node pointer */
} key_node;
typedef key_node* pkey_node;

typedef struct str_key_entry {
	uint4 relrec;    /* record number/node number */
	int1 key[1];              /* key value (key size - size of long)*/
} key_entry;
typedef key_entry* pkey_entry;

#ifdef __cplusplus
  }
#endif
#endif /* __KEY_STRU_H */
