#ifndef __KEY_UTIL_H
#define __KEY_UTIL_H
#include <fix_type.h>
#include <key_stru.h>
/* size of key node */
#define sz_node (512)

#ifdef __cplusplus
  extern "C" {
#endif
/* =========Functions	:===================*/
int2 key_gethdr( int hf, pkey_hdr phdr ); /* read header */
int2 key_puthdr( int hf, pkey_hdr phdr ); /* write header */
int2 key_getnode( int hf, uint4 n, pkey_node buf ); /* read node */
int2 key_putnode( int hf, uint4 n, pkey_node buf ); /* write node */
/* 'pnode' contents overwrites with next/prev node, if they exist;
 otherwise, no changes in 'pnode' */
int2 key_next_node( int hf, pkey_node pnode );
int2 key_prev_node( int hf, pkey_node pnode );

int2 key_findnode( int hf, void* buf, uint4 rec, pkey_node pnode,
	uint4* pn, int2* pi, int2* pcmp );
/* write correct parent for childs
 hf -
 pnode - node which child's considered,
 nn - 'pnode's number ( will be written as 'ulink' to childs )
 kl - key len, required to correct childs iterate,
 i0, i1 - indexes to iterate ( include i0, exclude i1 )
 */
int2 key_updatechilds( int hf, pkey_node pnode, uint4 nn, int2 kl, int2 i0, int2 i1 );

#ifdef __cplusplus
  }
#endif

#endif /* __KEY_UTIL_H */
