#define INCL_RXSHV
#define INCL_RXFUNC
#include <rexxsaa.h>

#define  INVALID_ROUTINE 40            /* Raise Rexx error           */
#define  VALID_ROUTINE    0            /* Successful completion      */

RexxFunctionHandler RxClaLoadFuncs;
RexxFunctionHandler RxClaDropFuncs;

static PSZ  RxFncTable[] = {
	"RxClaInfo",
  "RxClaGet",
	"RxClaLoadFuncs",
	"RxClaDropFuncs"
};

ULONG RxClaLoadFuncs(CHAR *name, ULONG numargs, RXSTRING args[],
                           CHAR *queuename, RXSTRING *retstr) {
  INT    entries=sizeof(RxFncTable)/sizeof(PSZ);
  INT    j=0;

  retstr->strlength = 0;               /* set return value           */
                                       /* check arguments            */
  if (numargs>0) return INVALID_ROUTINE;

  for ( j = 0; j<entries; j++ )
		RexxRegisterFunctionDll( RxFncTable[j], "RXCLA", RxFncTable[j] );
  return VALID_ROUTINE;
}

ULONG RxClaDropFuncs(CHAR *name, ULONG numargs, RXSTRING args[],
                          CHAR *queuename, RXSTRING *retstr) {
  INT     entries=sizeof(RxFncTable)/sizeof(PSZ);
  INT     j=0;

  if (numargs != 0) return INVALID_ROUTINE;

  retstr->strlength = 0;               /* return a null string result*/

  for ( j = 0; j<entries; j++ )
    RexxDeregisterFunction( RxFncTable[j] );
  return VALID_ROUTINE;                /* no error on call           */
}
