/*:VRX         Main
*/
/*  Main
*/
Main:
/*  Process the arguments.
    Get the parent window.
*/
    parse source . calledAs .
    parent = ""
    argCount = arg()
    argOff = 0
    if( calledAs \= "COMMAND" )then do
        if argCount >= 1 then do
            parent = arg(1)
            argCount = argCount - 1
            argOff = 1
        end
    end; else do
        call VROptions 'ImplicitNames'
        call VROptions 'NoEchoQuit'
    end
    InitArgs.0 = argCount
    if( argCount > 0 )then do i = 1 to argCount
        InitArgs.i = arg( i + argOff )
    end
    drop calledAs argCount argOff

/*  Load the windows
*/
    call VRInit
    parse source . . spec
    _VREPrimaryWindowPath = ,
        VRParseFileName( spec, "dpn" ) || ".VRW"
    _VREPrimaryWindow = ,
        VRLoad( parent, _VREPrimaryWindowPath )
    drop parent spec
    if( _VREPrimaryWindow == "" )then do
        call VRMessage "", "Cannot load window:" VRError(), ,
            "Error!"
        _VREReturnValue = 32000
        signal _VRELeaveMain
    end

/*  Process events
*/
    call Init
    signal on halt
    do while( \ VRGet( _VREPrimaryWindow, "Shutdown" ) )
        _VREEvent = VREvent()
        interpret _VREEvent
    end
_VREHalt:
    _VREReturnValue = Fini()
    call VRDestroy _VREPrimaryWindow
_VRELeaveMain:
    call VRFini
exit _VREReturnValue

VRLoadSecondary:
    __vrlsWait = abbrev( 'WAIT', translate(arg(2)), 1 )
    if __vrlsWait then do
        call VRFlush
    end
    __vrlsHWnd = VRLoad( VRWindow(), VRWindowPath(), arg(1) )
    if __vrlsHWnd = '' then signal __vrlsDone
    if __vrlsWait \= 1 then signal __vrlsDone
    call VRSet __vrlsHWnd, 'WindowMode', 'Modal' 
    __vrlsTmp = __vrlsWindows.0
    if( DataType(__vrlsTmp) \= 'NUM' ) then do
        __vrlsTmp = 1
    end
    else do
        __vrlsTmp = __vrlsTmp + 1
    end
    __vrlsWindows.__vrlsTmp = VRWindow( __vrlsHWnd )
    __vrlsWindows.0 = __vrlsTmp
    do while( VRIsValidObject( VRWindow() ) = 1 )
        __vrlsEvent = VREvent()
        interpret __vrlsEvent
    end
    __vrlsTmp = __vrlsWindows.0
    __vrlsWindows.0 = __vrlsTmp - 1
    call VRWindow __vrlsWindows.__vrlsTmp 
    __vrlsHWnd = ''
__vrlsDone:
return __vrlsHWnd

/*:VRX         FillInfo
*/
FillInfo: procedure 
    Arg FullName
    rc=RxClaInfo( FullName, ST. )
    hh = VRMethod( "CN_1", "AddRecord", , "", FullName, "", ,  )
    if rc = '' then do
        hDat = VRMethod( "CN_1", "AddRecord", hh, "", "Data", "", ,  )
        s="Fields (" ST.!DATA.!NUMFLDS ")" 
        hFld = VRMethod( "CN_1", "AddRecord", hh, "", s, "", ,  )
        s="Keys (" ST.!DATA.!NUMBKEYS ")"
        hKey = VRMethod( "CN_1", "AddRecord", hh, "", s, "", ,  )
        s="Arrays (" ST.!DATA.!NUMMARS ")"
        hArr = VRMethod( "CN_1", "AddRecord", hh, "", s, "", ,  )
        s="Pictures (" ST.!DATA.!NUMPICS ")"
        hPct = VRMethod( "CN_1", "AddRecord", hh, "", s, "", ,  )
        s="Memo (" ST.!DATA.!MEMOLEN " x " ST.!DATA.!MEMOWID ")"
        hMem = VRMethod( "CN_1", "AddRecord", hh, "", s, "", ,  )
        s="Attrib : " ST.!DATA.!SFATR
        h = VRMethod( "CN_1", "AddRecord", hDat, "", s, "", ,  )
        s="Records : " ST.!DATA.!NUMRECS
        h = VRMethod( "CN_1", "AddRecord", hDat, "", s, "", ,  )
        s="Deleted : " ST.!DATA.!NUMDELS
        h = VRMethod( "CN_1", "AddRecord", hDat, "", s, "", ,  )
        s="Free : " ST.!DATA.!FREEREC
        h = VRMethod( "CN_1", "AddRecord", hDat, "", s, "", ,  )
        s="Last Changed : " ST.!DATA.!CHGDATETIME
        h = VRMethod( "CN_1", "AddRecord", hDat, "", s, "", ,  )
        do i = 1 to ST.!FIELDS.0
            s=ST.!FIELDS.i.!NAME " (" ST.!FIELDS.i.!FLDTYPE ")" 
            hf = VRMethod( "CN_1", "AddRecord", hFld, "", s, "", ,  )
            s="Length(offset) : " ST.!FIELDS.i.!LENGTH "(" ST.!FIELDS.i.!FOFFSET ")"
            h = VRMethod( "CN_1", "AddRecord", hf, "", s, "", ,  )
            s="Decimal : " ST.!FIELDS.i.!DECSIG ":" ST.!FIELDS.i.!DECDEC
            h = VRMethod( "CN_1", "AddRecord", hf, "", s, "", ,  )
            s="Array : " ST.!FIELDS.i.!ARRNUM
            h = VRMethod( "CN_1", "AddRecord", hf, "", s, "", ,  )
            s="Picture : " ST.!FIELDS.i.!PICNUM
            h = VRMethod( "CN_1", "AddRecord", hf, "", s, "", ,  )
        end
        do i = 1 to ST.!KEYS.0
            s=ST.!KEYS.i.!NAME 
            hf = VRMethod( "CN_1", "AddRecord", hKey, "", s, "", ,  )
            s="Type : " ST.!KEYS.i.!COMPTYPE
            h = VRMethod( "CN_1", "AddRecord", hf, "", s, "", ,  )
            s="Components (" ST.!KEYS.i.!NUMCOMPS ") : " ST.!KEYS.i.!COMPLIST
            h = VRMethod( "CN_1", "AddRecord", hf, "", s, "", ,  )
            s="Length : " ST.!KEYS.i.!COMPLEN
            h = VRMethod( "CN_1", "AddRecord", hf, "", s, "", ,  )
        end
    end
    else do
        ok  = VRIsValidObject( "SW_1" )
        if ok = 0 then do
            window = VRLoadSecondary( "SW_1" )
            if window \= '' then do
                ok=1
            end
        end
        if ok = 1 then do
            hh = VRMethod( "CN_2", "AddRecord", , "", FullName, "", ,  )
            s="Error : " rc
            hDat = VRMethod( "CN_2", "AddRecord", hh, "", s, "", ,  )
        end
    end
return

/*:VRX         Fini
*/
Fini: procedure
    window = VRWindow()
    call VRSet window, "Visible", 0
    drop window
return 0

/*:VRX         Halt
*/
Halt:
    signal _VREHalt
return

/*:VRX         Init
*/
Init: procedure
    window = VRWindow()
    call VRMethod window, "CenterWindow"
    call VRSet window, "Visible", 1
    call VRMethod window, "Activate"
    drop window
    call RxFuncAdd 'RxClaLoadFuncs', 'RXCLA', 'RxClaLoadFuncs' 
    call RxClaLoadFuncs
return

/*:VRX         Menu_File_Delete_Click
*/
Menu_File_Delete_Click: 
call PB_4_Click
return

/*:VRX         Menu_File_Exit_Click
*/
Menu_File_Exit_Click: procedure
ok = VRMethod( "Window1", "PostEvent", "Close" )
return

/*:VRX         Menu_File_Open_Click
*/
Menu_File_Open_Click: 
call PB_1_Click
return

/*:VRX         Menu_File_Refresh_Click
*/
Menu_File_Refresh_Click: 
call PB_2_Click
return

/*:VRX         PB_1_Click
*/
PB_1_Click: procedure
rc = VRFileDialog( VRWindow(), "Select Clarion file", "Open", "*.dat", , , , "fname." )
ok = VRSet( "Window1", "Pointer", "Wait" )
do i = 1 to fname.0
    Call FillInfo fname.i
end
ok = VRSet( "Window1", "Pointer", "<Default>" )
return

/*:VRX         PB_2_Click
*/
PB_2_Click: procedure
ok = VRSet( "Window1", "Pointer", "Wait" )
ok = VRMethod( "CN_1", "GetRecordList", "Selected", "rec." )
do i=1 to rec.0
    pr = VRMethod( "CN_1", "GetRecordAttr", rec.i, "Parent" )
    if pr = '' then do
        fname=VRMethod( "CN_1", "GetRecordAttr", rec.i, "Caption" )
        ok = VRMethod( "CN_1", "RemoveRecord", rec.i )
        call FillInfo fname
    end
    else do
        ok  = Beep( "400", "200" )
    end    
end
ok = VRSet( "Window1", "Pointer", "<Default>" )
return

/*:VRX         PB_3_Click
*/
PB_3_Click: procedure
ok = VRMethod( "Window1", "PostEvent", "Close" )
return

/*:VRX         PB_4_Click
*/
PB_4_Click: procedure
ok = VRSet( "Window1", "Pointer", "Wait" )
ok = VRMethod( "CN_1", "GetRecordList", "Selected", "rec." )
do i=1 to rec.0
    pr = VRMethod( "CN_1", "GetRecordAttr", rec.i, "Parent" )
    if pr = '' then do
        ok = VRMethod( "CN_1", "RemoveRecord", rec.i )
    end
    else do
        ok  = Beep( "400", "200" )
    end    
end
ok = VRSet( "Window1", "Pointer", "<Default>" )
return

/*:VRX         Quit
*/
Quit: procedure
    window = VRWindow()
    call VRSet window, "Shutdown", 1
    drop window
return

/*:VRX         SW_1_Close
*/
SW_1_Close: 
    call SW_1_Fini
return

/*:VRX         SW_1_Create
*/
SW_1_Create: 
    call SW_1_Init
return

/*:VRX         SW_1_Fini
*/
SW_1_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         SW_1_Init
*/
SW_1_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window
return

/*:VRX         SW_1_Resize
*/
SW_1_Resize: procedure
x = VRGet( "SW_1", "InteriorHeight" )
ok = VRSet( "CN_2", "Height", x )
x = VRGet( "SW_1", "InteriorWidth" )
ok = VRSet( "CN_2", "Width", x )
return

/*:VRX         Window1_Close
*/
Window1_Close:
    call Quit
return

/*:VRX         Window1_Resize
*/
Window1_Resize: procedure
x = VRGet( "Window1", "InteriorHeight" )
ok = VRSet( "CN_1", "Height", x )
x = VRGet( "Window1", "InteriorWidth" )
x1 = VRGet( "GB_1", "Width" )
ok = VRSet( "CN_1", "Width", x-x1 )
ok = VRSet( "GB_1", "Left", x-x1 )
return

