/*:VRX         Main
*/
/*  Main
*/
Main:
/*  Process the arguments.
    Get the parent window.
*/
    parse source . calledAs .
    parent = ""
    argCount = arg()
    argOff = 0
    if( calledAs \= "COMMAND" )then do
        if argCount >= 1 then do
            parent = arg(1)
            argCount = argCount - 1
            argOff = 1
        end
    end; else do
        call VROptions 'ImplicitNames'
        call VROptions 'NoEchoQuit'
    end
    InitArgs.0 = argCount
    if( argCount > 0 )then do i = 1 to argCount
        InitArgs.i = arg( i + argOff )
    end
    drop calledAs argCount argOff

/*  Load the windows
*/
    call VRInit
    parse source . . spec
    _VREPrimaryWindowPath = ,
        VRParseFileName( spec, "dpn" ) || ".VRW"
    _VREPrimaryWindow = ,
        VRLoad( parent, _VREPrimaryWindowPath )
    drop parent spec
    if( _VREPrimaryWindow == "" )then do
        call VRMessage "", "Cannot load window:" VRError(), ,
            "Error!"
        _VREReturnValue = 32000
        signal _VRELeaveMain
    end

/*  Process events
*/
    call Init
    signal on halt
    do while( \ VRGet( _VREPrimaryWindow, "Shutdown" ) )
        _VREEvent = VREvent()
        interpret _VREEvent
    end
_VREHalt:
    _VREReturnValue = Fini()
    call VRDestroy _VREPrimaryWindow
_VRELeaveMain:
    call VRFini
exit _VREReturnValue

VRLoadSecondary:
    __vrlsWait = abbrev( 'WAIT', translate(arg(2)), 1 )
    if __vrlsWait then do
        call VRFlush
    end
    __vrlsHWnd = VRLoad( VRWindow(), VRWindowPath(), arg(1) )
    if __vrlsHWnd = '' then signal __vrlsDone
    if __vrlsWait \= 1 then signal __vrlsDone
    call VRSet __vrlsHWnd, 'WindowMode', 'Modal' 
    __vrlsTmp = __vrlsWindows.0
    if( DataType(__vrlsTmp) \= 'NUM' ) then do
        __vrlsTmp = 1
    end
    else do
        __vrlsTmp = __vrlsTmp + 1
    end
    __vrlsWindows.__vrlsTmp = VRWindow( __vrlsHWnd )
    __vrlsWindows.0 = __vrlsTmp
    do while( VRIsValidObject( VRWindow() ) = 1 )
        __vrlsEvent = VREvent()
        interpret __vrlsEvent
    end
    __vrlsTmp = __vrlsWindows.0
    __vrlsWindows.0 = __vrlsTmp - 1
    call VRWindow __vrlsWindows.__vrlsTmp 
    __vrlsHWnd = ''
__vrlsDone:
return __vrlsHWnd

/*:VRX         DisplayRecord
*/
DisplayRecord: procedure expose Rec. Field. FILEINFO.
    file=FILEINFO.!NAME
    key=0
    x=0
    rc = RxClaGet( file, "rr.", key ,x )
    if rc = '' then do
        
    end
    else do
        Lines.0 = 5
        Lines.1 = "Error reading record"
        Lines.2 = "File :" file
        Lines.3 = "Key :" key
        Lines.4 = "Condition :" x
        Lines.5 = rc
        id = VRMessageStem( VRWindow(), "Lines.", "Clarion file scanner", "Error", , ,  )
    end
return

/*:VRX         FileOpen
*/
FileOpen: procedure expose FILEINFO. Field. Rec.
    FileName = VRFileDialog( VRWindow(), "Open Clarion File", "Open", "*.dat", , ,  )
    if FileName \= '' then do
        drop FILEINFO. Field.
        rc = RxClaInfo( FileName, FILEINFO. )
        if rc = '' then do
/* File name */
            ok = VRSet( "DT_File", "Caption", FileName )
/* Keys */
            ok = VRMethod( "DDCB_Key", "Clear" )
            KeyList.0 = FILEINFO.!KEYS.0+1
            KeyData.0 = FILEINFO.!KEYS.0+1
            KeyList.1 = '<None>'
            KeyData.1 = 0
            do i = 1 to FILEINFO.!KEYS.0
                s = FILEINFO.!KEYS.i.!NAME 
                j=i+1
                KeyList.j=s
                KeyData.j=i
            end
            ok = VRMethod( "DDCB_Key", "AddStringList", "KeyList.", ,"KeyData." )
            ok = VRSet( "DDCB_Key", "Selected", 1 )
/* Fields */
            ok = VRMethod( "CN_Record", "RemoveRecord", "All" )
            FieldList.0 = FILEINFO.!FIELDS.0
            do i = 1 to FILEINFO.!FIELDS.0
                v.!nn = i
                v.!field = Strip( FILEINFO.!FIELDS.i.!NAME, "Both", " " )
                v.!type = FILEINFO.!FIELDS.i.!FLDTYPE
                v.!cont = ''
                select
                    when v.!type = STRING then do
                        v.!type = 'STR(' FILEINFO.!FIELDS.i.!LENGTH ')'
                    end
                    when v.!type = DECIMAL then do
                        v.!type = 'DEC(' FILEINFO.!FIELDS.i.!DECSIG+FILEINFO.!FIELDS.i.!DECDEC ':' FILEINFO.!FIELDS.i.!DECDEC ')'
                    end
                    otherwise do
                    end
                end
                s =';;;;;'Rec.!nn';'v.!nn';'Rec.!field';'v.!field';'Rec.!type';'v.!type';'Rec.!cont';'v.!cont';'
                FieldList.i = s
            end
            ok = VRMethod( "CN_Record", "AddRecordList", , "First", "FieldList.", "Field." )
            call DisplayRecord
        end
        else do
            Lines.0 = 3
            Lines.1 = "Error opening file"
            Lines.2 = "File :" FileName
            Lines.3 = rc
            id = VRMessageStem( VRWindow(), "Lines.", "Clarion file scanner", "Error", , ,  )
        end
    end
return

/*:VRX         Fini
*/
Fini:
    window = VRWindow()
    call VRSet window, "Visible", 0
    drop window
return 0

/*:VRX         Halt
*/
Halt:
    signal _VREHalt
return

/*:VRX         Init
*/
Init:
    window = VRWindow()
    call VRMethod window, "CenterWindow"
    call VRSet window, "Visible", 1
    call VRMethod window, "Activate"
    drop window
    call RxFuncAdd 'RxClaLoadFuncs', 'RXCLA', 'RxClaLoadFuncs' 
    call RxClaLoadFuncs
    call InitRecord
return

/*:VRX         InitRecord
*/
InitRecord: procedure expose Rec.
    Rec.!nn = VRMethod( "CN_Record", "AddField", "ULong", "NN" )
    ok = VRMethod( "CN_Record", "SetFieldAttr", Rec.!nn, "ReadOnly", 1, "Title", "NN", "VertSeparator", 1 )
    Rec.!field = VRMethod( "CN_Record", "AddField", "String", "Field" )
    ok = VRMethod( "CN_Record", "SetFieldAttr", Rec.!field, "ReadOnly", 1, "Title", "Field", "VertSeparator", 1 )
    Rec.!type = VRMethod( "CN_Record", "AddField", "String", "Type" )
    ok = VRMethod( "CN_Record", "SetFieldAttr", Rec.!type, "ReadOnly", 1, "Title", "Type", "VertSeparator", 1 )
    Rec.!cont = VRMethod( "CN_Record", "AddField", "String", "Contents" )
    ok = VRMethod( "CN_Record", "SetFieldAttr", Rec.!cont, "ReadOnly", 0, "Title", "Contents", "VertSeparator", 1 )
    width = VRGet( "CN_Record", "Width" )
    ok = VRSet( "CN_Record", "SplitBarLeft", width/2 )
    ok = VRSet( "CN_Record", "LastSplitField", Rec.!type )
return


/*:VRX         MenuFileExit_Click
*/
MenuFileExit_Click: 
    ok = VRMethod( "WinMain", "PostEvent", "Close" )
return

/*:VRX         MenuFileOpen_Click
*/
MenuFileOpen_Click: 
    call FileOpen
return

/*:VRX         PB_Exit_Click
*/
PB_Exit_Click: 
    ok = VRMethod( "WinMain", "PostEvent", "Close" )
return

/*:VRX         PB_Open_Click
*/
PB_Open_Click:
    call FileOpen
return

/*:VRX         Quit
*/
Quit:
    window = VRWindow()
    call VRSet window, "Shutdown", 1
    drop window
return

/*:VRX         WinMain_Close
*/
WinMain_Close:
    call Quit
return

